<?php

namespace Drupal\graphql_tablefield_schema\Plugin\GraphQL\SchemaExtension;

use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\graphql\GraphQL\ResolverBuilder;
use Drupal\graphql\GraphQL\ResolverRegistryInterface;
use Drupal\graphql\Plugin\GraphQL\SchemaExtension\SdlSchemaExtensionPluginBase;

/**
 * A schema extension for the table field element.
 *
 * @SchemaExtension(
 *   id = "tablefield",
 *   name = "Tablefield",
 *   description = "An extension that provides an array of rows for tablefield fields.",
 *   schema = "core_composable"
 * )
 */
class TablefieldExtension extends SdlSchemaExtensionPluginBase implements ContainerFactoryPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function getBaseDefinition() {
    return '';
  }

  /**
   * {@inheritdoc}
   */
  public function registerResolvers(ResolverRegistryInterface $registry): void {
    $builder = new ResolverBuilder();

    $registry->addFieldResolver('FieldItemTypeTablefield', 'rows',
      $builder->produce('tablefield')
        ->map('table', $builder->fromParent())
    );
  }

}
